/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-21 15:27:30 UTC)
 * on 2013-08-28 at 15:45:30 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.youtube.model;

/**
 * Represent a property available in different languages.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the YouTube Data API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class LocalizedProperty extends com.google.api.client.json.GenericJson {

  /**
   * Default value for the localized property.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key("default")
  private java.lang.String youtubeDefault;

  /**
   * The localized values.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<LocalizedString> localized;

  /**
   * Default value for the localized property.
   * @return value or {@code null} for none
   */
  public java.lang.String getDefault() {
    return youtubeDefault;
  }

  /**
   * Default value for the localized property.
   * @param youtubeDefault youtubeDefault or {@code null} for none
   */
  public LocalizedProperty setDefault(java.lang.String youtubeDefault) {
    this.youtubeDefault = youtubeDefault;
    return this;
  }

  /**
   * The localized values.
   * @return value or {@code null} for none
   */
  public java.util.List<LocalizedString> getLocalized() {
    return localized;
  }

  /**
   * The localized values.
   * @param localized localized or {@code null} for none
   */
  public LocalizedProperty setLocalized(java.util.List<LocalizedString> localized) {
    this.localized = localized;
    return this;
  }

  @Override
  public LocalizedProperty set(String fieldName, Object value) {
    return (LocalizedProperty) super.set(fieldName, value);
  }

  @Override
  public LocalizedProperty clone() {
    return (LocalizedProperty) super.clone();
  }

}
