/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-21 15:27:30 UTC)
 * on 2013-08-28 at 15:45:30 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.youtube.model;

/**
 * Details about monetization of a YouTube Video.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the YouTube Data API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class VideoMonetizationDetails extends com.google.api.client.json.GenericJson {

  /**
   * The value of access indicates whether the video can be monetized or not.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private AccessPolicy access;

  /**
   * The value of access indicates whether the video can be monetized or not.
   * @return value or {@code null} for none
   */
  public AccessPolicy getAccess() {
    return access;
  }

  /**
   * The value of access indicates whether the video can be monetized or not.
   * @param access access or {@code null} for none
   */
  public VideoMonetizationDetails setAccess(AccessPolicy access) {
    this.access = access;
    return this;
  }

  @Override
  public VideoMonetizationDetails set(String fieldName, Object value) {
    return (VideoMonetizationDetails) super.set(fieldName, value);
  }

  @Override
  public VideoMonetizationDetails clone() {
    return (VideoMonetizationDetails) super.clone();
  }

}
